* MANOVA DATA FROM MORRISONS MULTIVARIATE TEXT, 2ND EDITION, PAGE 190,
 3rd Ed, p. 210;
Title 'Two Way Manova Example';

data drugs;
* Rats are given one of 3 types of drug. weight loss (grams)
* is the dependent measure over two weeks (Y1, Y2);
   Label Y1='Week1'
    	 Y2='Week2';
   INPUT sex $ drug $ @;           *<-- read several obs. per line;
	  input y1 y2 @; output;
	  input y1 y2 @; output;
	  input y1 y2 @; output;
	  input y1 y2 @; output;
datalines;
M A    5  6   5  4   9  9   7  6
M B    7  6   7  7   9 12   6  8
M C   21 15  14 11  17 12  12 10
F A    7 10   6  6   9  7   8 10
F B   10 13   8  7   7  6   6  9
F C   16 12  14  9  14  8  10  5
;
data drugs;
	set drugs;
	group = trim(sex) || ':' || drug;
run;

*ods listing close;
proc glm outstat=stats;
     classes sex drug;
     model y1 y2 = sex drug sex*drug /nouni ss3;
	 manova h=sex drug sex*drug / short;
run;
*ods listing;

%include goptions;
*include macros(heplot);
goptions htext=1.8 htitle=2.4 vpos=60 hpos=100 vsize=7in;
proc print data=stats;

%gdispla(OFF);
data drugs;
	set drugs;
	group = trim(sex) || ':' || drug;
run;

%let p=0.68;
title "(a) &p Data Ellipses: Sex:Drug";
*-- specify axes to scale H,V the same in all plots;
axis1 order=(0 to 25 by 5) ;
axis2 order=(0 to 16 by 4) label=(a=90 r=0);	
%ellipses(data=drugs, x=Y1, y=Y2, class=group, haxis=axis1, vaxis=axis2,
	colors=red red red blue blue blue, pvalue=&p,
	symbols=dot circle square dot circle square);

%let M1=H+E;
%let M1=H;
%let scale= 1 1;
*let scale=dfe/dfh 1;
*-- specify an axis to scale H,V equally;
title "(b) Sex Effect";
legend1 position=(bottom center inside) offset=(0,1) mode=share frame;
%heplot(data=drugs, stat=stats, var=Y1 Y2, effect=SEX, pvalue=&p,
	haxis=axis1, vaxis=axis2, legend=legend1, M1=&M1, scale=&scale);
%gskip;

title "(c) Drug Effect";
%heplot(data=drugs, stat=stats, var=Y1 Y2, effect=Drug, pvalue=&p,
	haxis=axis1, vaxis=axis2, legend=legend1, M1=&M1, scale=&scale);
%gskip;

title "(d) Sex*Drug Effect";
%heplot(data=drugs, stat=stats, var=Y1 Y2, effect=Sex*Drug, pvalue=&p,
	haxis=axis1, vaxis=axis2, legend=legend1, M1=&M1, scale=&scale);
 
%gdispla(ON);
%panels(rows=2,cols=2, plots=4, order=down);

