%include goptions;
goptions vsize=7.6 in htext=1.6;
%include data(iris);
*include macros(heplot13t);
title;
%gdispla(OFF);


title; * 'HE-plot for Iris data, with contrasts';
proc glm data=iris outstat=stats;
   class species;
   model SepalLen sepalwid PetalLen petalwid = species / nouni ss3;
   contrast 'S:VV' species -2  1  1;
   contrast 'V:V'  species  0 -1  1;
   manova H=species /short summary;
proc print data=stats;

axis1 label=(a=90) order=(45 to 70 by 5);
axis2 order=(24 to 38 by 2);
legend1 position=(bottom center inside) offset=(0,1) mode=share frame;
%heplot(data=iris,stat=stats, var= SepalWid SepalLen, effect=species, 
    vaxis=axis1, haxis=axis2, legend=legend1);

%heplot(data=iris,stat=stats, var= SepalWid SepalLen, 
   effect=S:VV, ss=contrast, class=, efflab=S:VV,
   vaxis=axis1, haxis=axis2, legend=legend1);
%heplot(data=iris,stat=stats, var= SepalWid SepalLen,
   effect=V:V, ss=contrast, class=, efflab=V:V,
   vaxis=axis1, haxis=axis2, legend=legend1);
%gdispla(ON);

%panels(rows=1, cols=1, replay=1:1 1:2 1:3);

