title 'HE plots for multivariate multiple regression';
data lo_ses (label='Timm Example 4.7');
*
*  TIMM - Example 4.7 (p.313)
 Scores for kindergarten children from a low SES area on:
   PPVT - Peabody Picture Vocab test
   SAT  - Student achievement test
   RAVEN- Raven progressive matrices
 Predictors: various measures of paired-associate learning;
 
   input SAT PPVT RAVEN N S NS NA SS;
   label sat='Student achievement test'
         ppvt='Peabody picture vocabulary test'
         raven='Raven progressive matrices test'
         n='Named P.A. learning test'
         s='Still P.A. learning test'
         ns='Named Still P.A. learning test'
         na='Named Action P.A. learning'
         ss='Sentence Still P.A. learning';
   subjno=_n_;
datalines;
 49 48  8  1  2  6 12 16
 47 76 13  5 14 14 30 27
 11 40 13  0 10 21 16 16
  9 52  9  0  2  5 17  8
 69 63 15  2  7 11 26 17
 35 82 14  2 15 21 34 25
  6 71 21  0  1 20 23 18
  8 68  8  0  0 10 19 14
 49 74 11  0  0  7 16 13
  8 70 15  3  2 21 26 25
 47 70 15  8 16 15 35 24
  6 61 11  5  4  7 15 14
 14 54 12  1 12 13 27 21
 30 55 13  2  1 12 20 17
  4 54 10  3 12 20 26 22
 24 40 14  0  2  5 14  8
 19 66 13  7 12 21 35 27
 45 54 10  0  6  6 14 16
 22 64 14 12  8 19 27 26
 16 47 16  3  9 15 18 10
 32 48 16  0  7  9 14 18
 37 52 14  4  6 20 26 26
 47 74 19  4  9 14 23 23
  5 57 12  0  2  4 11  8
  6 57 10  0  1 16 15 17
 60 80 11  3  8 18 28 21
 58 78 13  1 18 19 34 23
  6 70 16  2 11  9 23 11
 16 47 14  0 10  7 12  8
 45 94 19  8 10 28 32 32
  9 63 11  2 12  5 25 14
 69 76 16  7 11 18 29 21
 35 59 11 2  5 10 23 24
 19 55  8  0  1 14 19 12
 58 74 14  1  0 10 18 18
 58 71 17  6  4 23 31 26
 79 54 14  0  6  6 15 14
;

*-- Get HE matrices for overall test;
%hemreg(data=lo_ses, 
   y=SAT PPVT RAVEN, x=N S NS NA SS, 
   out=HEoverall, Hyp=Overall);

%let ss=ss3;
*-- Get H matrices for separate predictors;
proc glm data=lo_ses outstat=HE_Xs;
  model sat ppvt raven = n s ns na ss / &ss nouni;
  manova  h=_all_/  short;
run;
  

title;
%include goptions;
%gdispla(OFF);
axis1 order=(40 to 80 by 10) label=(a=90 r=0);
axis2 order=(-10 to 70 by 10);
%heplot(stat=HEoverall, data=lo_ses, 
   var=sat ppvt, 
   effect=Overall, /* name of H matrix from %hemreg */
   mplot=1,        /* plot only H matrix */
   class=%str( ),  /* override default class=&effect */ 
   legend=none, efflab=Regr,
   vaxis=axis1, haxis=axis2); 
  

%heplot(stat=HE_Xs, data=lo_ses, var=sat ppvt raven, effect=N, 
   ss=&ss, legend=none, efflab=N, class=%str( ), 
   vaxis=axis1, haxis=axis2);
%heplot(stat=HE_Xs, data=lo_ses, var=sat ppvt raven, effect=S, 
   ss=&ss, legend=none, efflab=S, class=%str( ),
   vaxis=axis1, haxis=axis2);
%heplot(stat=HE_Xs, data=lo_ses, var=sat ppvt raven, effect=NS,
   ss=&ss, legend=none, efflab=NS, class=%str( ),
   vaxis=axis1, haxis=axis2);
%heplot(stat=HE_Xs, data=lo_ses, var=sat ppvt raven, effect=NA, 
   ss=&ss, legend=none, efflab=NA, class=%str( ),
   vaxis=axis1, haxis=axis2);
%heplot(stat=HE_Xs, data=lo_ses, var=sat ppvt raven, effect=SS, 
   ss=&ss, legend=none, efflab=SS, class=%str( ),
   vaxis=axis1, haxis=axis2);
%gdispla(ON);

%panels(rows=1, cols=1,
   replay=1:1 1:2 1:3 1:4 1:5 1:6);

data stats;
   set HEoverall HE_Xs;
proc print;
   id _name_ _source_ _type_; 
